#!/usr/bin/perl
#
#
# 2007/08/13 by vdrchuck
#
# vdr-portal.pl - v.0.1

use strict;
use warnings;
use Socket;

# Script and conf dir
my $dir = "/usr/local/etc/vdr/plugins/osdserver/vdr-portal";

# Debug=1 temp files in $tempdir nich lschen
my $debug = 0;

my $tempdir = "/tmp";


##
## Don't change anything after here ;)
##

# Global
my $conffile = "$dir/vdr-portal.conf";
my $width;
my $recursiv;
my $pointer = 0;
my @UrlList;
@UrlList = readfile("$dir/url.conf");

# Convenient return values
my $true = 1;
my $false = 0;


##################################### vdr-portal #######################################

sub board {
    my $url = shift;
    my $link = shift;
    my (@result,@links);
    # Raw HTML holen
    chomp($url);
    system "lynx -dump -source -connect_timeout=5 -hiddenlinks=ignore '$url' > $tempdir/raw.html";
    @result = readfile("$tempdir/raw.html");
    if ($#result == -1) {@result=('Timeout: 5s - Seite nicht erreichbar!');&writefile("$tempdir/surfer.tmp",\@result);exit;}
    # Filtern der Boardbeitrge
    @result = &getline('<a href="thread\.php\?threadid=','<\/a><\/span><span class="smallfont">',\@result);
    # Anpassungen fr die Boardview
    @result = &forum_view(\@result);
    # Nicht bentigte Zeichen hinter den Links lschen
    @result = &delcharafter('<\/a><br>',\@result);
    @result = &clear_umlaute(\@result);
    &writefile("$tempdir/parsed.raw.html",\@result);
    system "lynx -dump -hiddenlinks=ignore -width=$width $tempdir/parsed.raw.html > $tempdir/lynx.tmp" and die "lynx konnte nicht ausgefhrt werden\n";
    # Schreiben der surfer.tmp
    @result = readfile("$tempdir/lynx.tmp");
    @links = @result;
    @result = &blockfilter('\[1\]','Verweise',\@result);
    @result = &blockfilter('\[1\]','References',\@result);
    @result = &deleteline("^Verweise",'',\@result);
    @result = &deleteline("^References",'',\@result);
    @result = &changeline('^\s*','',\@result);
    &writefile("$tempdir/surfer.tmp",\@result);
    # Schreiben der surfer.tmp.lnk
    @links = (@links, "---END---");
    @links = &blockfilter('Verweise','---END---',\@links);
    @links = &blockfilter('References','---END---',\@links);
    @links = &deleteline("^Verweise",'',\@links);
    @links = &deleteline("^References",'',\@links);
    @links = &deleteline("^---END---",'',\@links);
    @links = &changeline('^ .....','',\@links);
    @links = &changeline('^\s*','',\@links);
    &writefile("$tempdir/surfer.tmp.lnk",\@links);
    if (!$debug) {clean_tmp();}
    return @result;
}

sub thread {
    my $url = shift;
    my $link = shift;
    my @result;
    my @links;
    my @title;
    # Raw HTML holen
    chomp($url);
    system "lynx -dump -source -hiddenlinks=ignore -connect_timeout=5 '$url' > $tempdir/raw.html";
    @result = readfile("$tempdir/raw.html");
    if ($#result == -1) {@result=('Timeout: 5s - Seite nicht erreichbar!');&writefile("$tempdir/surfer.tmp",\@result);exit}
    @result = readfile("$tempdir/raw.html");
    # Filtern der raw.html
    @result = &cleanblock('<meta http-equiv="Content-Type"','</head>',\@result);
    @result = &cleanblock1('<title>','<span class="smallfont"><b>Author</b></span></td>',\@result);
    @result = &cleanblock1('<title>','<span class="smallfont"><b>Autor</b></span></td>',\@result);
    @result = &cleanblock('<form action="board.php" method="get" name="jumpform">','</body>',\@result);
    # Entfernen der Signatur
    @result = &cleanblock('<br \/><br \/>__________________<br \/>','<td class="table[a|b]" align="center" nowrap="nowrap"><span class="smallfont">',\@result);
    #Vor dem Beitragsdatum eine Zeile/Absatz einfgen (Marke setzen --> diese wird spter entfernt)
    @result = &changeline('<a href="thread.php\?postid=','<br>---SETZE-MARKE--- <br><a href="thread.php?postid=',\@result);
    # Anpassungen an die spez. Portal Threadview (Username, ...)
    @result = &forum_thread(\@result);
    # Zeilen lschen
    @result = &cleanblock('<img src="images/user_o\w*\.gif"','<a href="usercp.php\?action=buddy',\@result);
    @result = &cleanblock1('<span class="normalfont"><b>Beitrag von: ','<br /><img src="images/spacer.gif"',\@result);
    @result = &deleteline('<a href="addreply.php\?postid=','title="Go to the top of this page" /></a></td>',\@result);
    @result = &deleteline('<a href="addreply.php\?postid=','title="Zum Anfang der Seite springen" /></a></td>',\@result);    
    @result = &deleteline('>Tree Structure</a> | <a href="thread.php','>Board Structure</a></span>',\@result);
    @result = &deleteline('>Baumstruktur</a> | <a href="thread.php','>Brettstruktur</a></span>',\@result);
    @result = &deleteline('<a href="http:\/\/web.icq.com\/whitepages\/add_me','your Contact List',\@result);
    @result = &deleteline('<a href="http:\/\/web.icq.com\/whitepages\/add_me','in Ihre Kontaktliste ein',\@result);
    @result = &deleteline('<a href="aim:goim\?screenname=','<img src="images\/aim.gif',\@result);
    @result = &deleteline('<a href="http:\/\/members.msn.com\/\?mem=','<img src="images\/msn.gif',\@result);
    # CodeTags 1:2:3:.... entfernen
    @result = &cleanblock("<td class='inposttable' nowrap='nowrap' align='right'><pre>",'</pre></td>',\@result);
    @result = &codetag(\@result);
    # Damit die LF im -dump funktionieren
    @result = &changeline('^<br />','<p><br /></p>',\@result);
    # 
    @title = &getline('<title>','<\/title>',\@result);
    @title = &changeline('<title>','',\@title);
    @title = &changeline('<\/title>','',\@title);
    &writefile("$tempdir/parsed.raw.html",\@result);
    system "lynx -hiddenlinks=ignore -dump -width=$width $tempdir/parsed.raw.html > $tempdir/lynx.tmp" and die "lynx konnte nicht ausgefhrt werden\n";
    # Zeilen lschen
    @result = readfile("$tempdir/lynx.tmp");
    @result = (@result, "---END---\n");
    @result = &cleanblock('Verweise','---END---',\@result);
    @result = &cleanblock('References','---END---',\@result);
    @result = &changeline('^\s\s\s','',\@result);
    @result = &deleteline('Post  Previous Thread | Next Thread ','',\@result);
    @result = &deleteline('Beitrag  Vorheriges Thema | Nchstes Thema ','',\@result);
    @result = &deleteline('Previous Thread','Next Thread',\@result);
    @result = &deleteline('Vorheriges Thema','Nchstes Thema',\@result);
    @result = &deleteline('Pages','previous',\@result);
    @result = &deleteline('Seiten','vorherige',\@result);
    @result = &deleteline('Author','',\@result);
    @result = &deleteline('Autor','',\@result);
    @result = &changeline('---SETZE-MARKE---','',\@result);
    @result = &changeline('THE_TITLE:VDR Portal ','',\@result);
    @result = ($title[0],@result);
    splice(@result,1,2);
    #
    @result = &clear_umlaute(\@result);
    @result = &newsquote(\@result);
    if ($recursiv) {@result = &msg_recursiv(\@result);}

    # Schreiben der surfer.tmp
    &writefile("$tempdir/surfer.tmp",\@result);
    if (!$debug) {clean_tmp();}
    return @result;
}
# Beitrge recursiv anordnen
sub msg_recursiv {
    my $ary_ref = shift;
    my ($ueberschrift, @header, @body, @result);
    my $i = 0;
    my $j = 0;
    my $array_anzahl=@$ary_ref;    
    $ueberschrift = $ary_ref->[0];
    while ( $ary_ref->[$i] !~ /^  ___*/) {
	$i++;
	if ($i > $array_anzahl) {return @$ary_ref;}
    }
    while ($i <= $array_anzahl) {        
        no warnings 'uninitialized';
	$j++;
        $header[$j] = $header[$j] . $ary_ref->[$i++];

	while ( $ary_ref->[$i] !~ /^  ___*/) {
            $header[$j] = $header[$j] . $ary_ref->[$i++];
        }
        $header[$j] = $header[$j] . $ary_ref->[$i++];
        while ( $ary_ref->[$i] !~ /^  ___*/ and $i <= $array_anzahl) {$body[$j] = $body[$j] . $ary_ref->[$i++];}
    }
    @body = reverse(@body);
    @header = reverse(@header);
    while ($j >= 0) {
        no warnings 'uninitialized';
	$result[$j] = $header[$j] . $body[$j];
        $j--; 
    }
    @result = ($ueberschrift,"\n","\n",@result);
    splice(@result,1,2);
    return @result;
}

# Clean tmp files
sub clean_tmp {
    unlink "$tempdir/parsed.raw.html";
    unlink "$tempdir/lynx.tmp";
    unlink "$tempdir/raw.html";
}

# Zeilen werden anhand $muster, $ersatz ersetzt. bergabe:$muster,$ersatz,@data
sub changeline {
    my $muster = shift;
    my $ersatz = shift;
    my $ary_ref = shift;
    my ($i, @blockdata);
    $i = 0;
    for (my $z=0;$z < @$ary_ref;$z++) {
        $ary_ref->[$z] =~ s/$muster/$ersatz/;
        $blockdata[$i++] = $ary_ref->[$z];
    }
    return @blockdata;
}

# HTML Umlaute entfernen
sub clear_umlaute {
    my $ary_ref = shift;
    my ($i, @blockdata);    
    $i = 0;
    for (my $z=0;$z < @$ary_ref;$z++) {
        $ary_ref->[$z] =~ s/&Auml;//g;
        $ary_ref->[$z] =~ s/&Ouml;//g;        
        $ary_ref->[$z] =~ s/&Uuml;//g;	
        $ary_ref->[$z] =~ s/&auml;//g;	
        $ary_ref->[$z] =~ s/&ouml;//g;
        $ary_ref->[$z] =~ s/&uuml;//g;
        $ary_ref->[$z] =~ s/&amp;/&/g;	
        $ary_ref->[$z] =~ s/&quot;/\"/g;		
        $ary_ref->[$z] =~ s/&lt;/</g;			
        $ary_ref->[$z] =~ s/&gt;/>/g;			
        $ary_ref->[$z] =~ s/&nbsp;/ /g;		
        $ary_ref->[$z] =~ s/&acute;/\'/g;		
        $ary_ref->[$z] =~ s/&divide;/:/g;		
        $ary_ref->[$z] =~ s/&sim;/~/g;
        $ary_ref->[$z] =~ s/&szlig;//g;				
	$blockdata[$i++] = $ary_ref->[$z];
    }
    return @blockdata;
}

# Code Tags erneut markieren markieren(1., 2., ...). bergabe:@Data
sub codetag {
    my $ary_ref = shift;
    my $i = 0;
    my $set = 0;
    my $zaehler = 1;
    my $array_anzahl = @$ary_ref;
    my @result;
    while ($i <= $array_anzahl) {
	if (defined $ary_ref->[$i]) {
	    if ($ary_ref->[$i] =~ s/<td valign='top' class='inposttable' nowrap='nowrap' align='left' style='width:100%'><pre>/<td valign='top' class='inposttable' nowrap='nowrap' align='left' style='width:100%'><pre><table>1: /) {
		$set=1;
	    }    
	}        
	if ($set == 1 and $zaehler == 1) { $ary_ref->[$i] = $ary_ref->[$i];}
        if ($set == 1 and $zaehler >= 2) { $ary_ref->[$i] = $zaehler . ": " . $ary_ref->[$i];}	
	if ($set == 1) {$zaehler++;}
        if (defined $ary_ref->[$i]) {
	    if ($ary_ref->[$i] =~ /<\/pre><\/td>/) { $set=0;$zaehler=1; }
        }
	$i++;
    }
    return @$ary_ref;
}

# Quotes werden Newsmssig markiert. bergabe:@Data
sub newsquote {
    my $ary_ref = shift;
    my $i = 0;
    my $set = 0;
    my $array_anzahl = @$ary_ref;
    while ($i <= $array_anzahl) {    
	if (defined $ary_ref->[$i]) {
    	    if ($ary_ref->[$i] =~ s/-QuoteStart-//) {splice(@$ary_ref,$i,1); $set++; }
    	    if ($ary_ref->[$i] =~ s/-QuoteEnde-//) { splice(@$ary_ref,$i,1); $set--; }
	}
	# Markierung von fnf mglichen Quotes -> noch nichts gefunden fr 'print ">" $set mal' ???
        if ($set == 1) {$ary_ref->[$i] = ">" . $ary_ref->[$i];}
        if ($set == 2) {$ary_ref->[$i] = ">>" . $ary_ref->[$i];}
        if ($set == 3) {$ary_ref->[$i] = ">>>" . $ary_ref->[$i];}
        if ($set == 4) {$ary_ref->[$i] = ">>>>" . $ary_ref->[$i];}
        if ($set == 5) {$ary_ref->[$i] = ">>>>" . $ary_ref->[$i];}
        $i++;
    }
    return @$ary_ref;
}

# Zeichen aus der Zeile lschen ab $muster. bergabe:$muster,@data
sub delcharafter {
    my $muster = shift;
    my $ary_ref = shift;    
    my ($i, @blockdata);    
    for (my $z=0;$z < @$ary_ref;$z++) {
        $ary_ref->[$z] =~ /($muster)/;
        $blockdata[$i++] = $ary_ref->[$z] = $` . $&;
    }
    return @blockdata;
}

# VDR-Portal Startseite spez. Anpassungen. bergabe: @data
sub forum_view {
    my $ary_ref = shift;
    my ($set, $i, @blockdata);
    for (my $z=0;$z < @$ary_ref;$z++) {
        if ($ary_ref->[$z] =~ s/<a href=\"thread\.php\?threadid/<a href=\"http:\/\/www.vdr-portal.de\/board\/thread\.php\?threadid/) {$set=1;}
        if ($ary_ref->[$z] =~ s/<\/a><\/span><span class=\"smallfont\">/<\/a><br>/) {$set=1;}
        if ($ary_ref->[$z] =~ s/amp;sid\=\w*/goto=lastpost/) {$set=1;}
        if ($ary_ref->[$z] =~ s/^  //) {$set=1;}
        if ($set==1) {$blockdata[$i++] = $ary_ref->[$z];}
        $set=0;
    }
    return @blockdata;
}

# VDR-Portal Thread spez. Anpassungen. bergabe: @data (Username ermitteln,...)
sub forum_thread {
    my ($i, $temp, @blockdata, $qname);
    my $ary_ref = shift;
    my $qtable = 0 ;
    for (my $z=0;$z < @$ary_ref;$z++) {
        if ($ary_ref->[$z] =~ /<td class="table[a|b]" valign="top"><a name=/) {
            $ary_ref->[$z] = '</table><hr size="1" class="threadline" />';
        }
        if ($ary_ref->[$z] =~ /class="time"/) {
            $blockdata[$i++] = "<br>"
        }
        # Start - Formatierungen fr Quotes, Attachemnts .....
        # Table fr Zitate
	if ($ary_ref->[$z] =~ /<table align="center" width="98%" cellpadding="4" cellspacing="1" class="tableinborder">/) {
            $qtable++;
        }
        if ($ary_ref->[$z] =~ /(<td align=\"left\" class=\"tablecat\"><span class=\"smallfont\"><b>)/ ) {
            $qname = $';
            if ($qname =~ /(<\/b>)/) {
                $qname = $`;
            }
            $ary_ref->[$z] = '<td align="left" class="tablecat"><span class="smallfont"><b><center>'.$qtable.'. '.$qname.'-QuoteStart-</center><table>'.'</b>';
        }

        if ($qtable > 0 and $ary_ref->[$z] =~ /(<\/table>)/) {
            $ary_ref->[$z] = '</table><center>'. '['.$qtable.'. '.$qname.']-QuoteEnde-</center></table><table align="left">' . $';
            $qtable--;
        }
        # Ende - Formatierungen fr Quotes, Attachemnts .....
        #
	# Username separieren
        if ($ary_ref->[$z] =~ /(<td style=\"width:100%\" class=\"smallfont\"><span class=\"normalfont\"><b><a href=\"profile.php\?userid=.*\">)/) {
            $temp = $';
            if ($temp =~ /(<\/a><\/b><\/span>)/) {
                $temp =  $`;
            }
            $ary_ref->[$z] = '<td style="width:100%" class="smallfont"><span class="normalfont"><b>Beitrag von: ' . $temp . '</b></td>';
        }
        $blockdata[$i++] = $ary_ref->[$z];
    }
    return @blockdata;
}

# Einzelne Zeilen werden per Suchmuster bergeben. bergabe: @(musterlinestart,musterlineende),@data
sub getline {
    my $start = shift;
    my $ende  = shift;
    my $ary_ref = shift;
    my (@blockdata);
    my $set=0;
    my $i= 0;
    for (my $z=0;$z < @$ary_ref;$z++) {
        if ( ($ary_ref->[$z] =~ /$start/) and ($ary_ref->[$z] =~ /$ende/) ) {$set=1;}
        if ($set==1) {$blockdata[$i++] = $ary_ref->[$z];}
        $set=0;
    }
    return @blockdata;
}

# Einzelne Zeilen werden per Suchmuster gelscht. bergabe: @(musterlinestart,musterlineende),@data
sub deleteline {
    my @blockdata;
    my $start = shift;
    my $ende  = shift;
    my $ary_ref = shift;
    my $set = 0;
    my $i = 0;
    for (my $z=0;$z < @$ary_ref;$z++) {
        if ( ($ary_ref->[$z] =~ /$start/) and ($ary_ref->[$z] =~ /$ende/) ) {$set=1;}
        if ($set==0) {$blockdata[$i++] = $ary_ref->[$z];}
        $set=0;
    }
    return @blockdata;
}

# bergabe von Blockdaten ber mehrere Zeilen. bergabe: @(musterlinestart,musterlineende),@data
sub blockfilter {
    my $start = shift;
    my $ende = shift;
    my $ary_ref = shift;
    my $notfound = 1;
    my @blockdata;    
    my $set = 0;
    my $i = 0;
    for (my $z=0;$z < @$ary_ref;$z++) {
        if ($ary_ref->[$z] =~ /$start/) {$set=1;$notfound=0;}
        if ($set==1) {$blockdata[$i++] = $ary_ref->[$z];}
        if ($ary_ref->[$z] =~ /$ende/) {$set=0;}
    }
    return @$ary_ref if ($notfound == 1);
    return @blockdata if ($notfound == 0);
}

# Lschen von Blockdaten ber mehrere Zeilen. bergabe: @(musterlinestart,musterlineende),@data
sub cleanblock {
    my @blockdata;
    my $start = shift;
    my $ende  = shift;
    my $ary_ref = shift;
    my $set = 0;
    my $i = 0;
    my $notfound = 1;
    for (my $z=0;$z < @$ary_ref;$z++) {
        if ($ary_ref->[$z] =~ /$start/) {$set=1;$notfound=0;}
        if ($set==0) {$blockdata[$i++] = $ary_ref->[$z];}
        if ($ary_ref->[$z] =~ /$ende/) {$set=0;}
    }
    return @$ary_ref if ($notfound == 1);
    return @blockdata if ($notfound == 0);

}
# Lschen von Blockdaten ber mehrere Zeilen(Start- und Endzeile werden NICHT mit gelscht). bergabe: @(musterlinestart,musterlineende),@data
sub cleanblock1 {
    my @blockdata;
    my $start = shift;
    my $ende  = shift;
    my $ary_ref = shift;    
    my $set = 0;
    my $i = 0;
    my $notfound = 1;
    for (my $z=0;$z < @$ary_ref;$z++) {
        if ($ary_ref->[$z] =~ /$ende/) {$set=0;$notfound=0;}
        if ($set==0) {$blockdata[$i++] = $ary_ref->[$z];}
        if ($ary_ref->[$z] =~ /$start/) {$set=1;}
    }
    return @$ary_ref if ($notfound == 1);
    return @blockdata if ($notfound == 0);
}

# Datei lesen
sub readfile {
    my $filename = shift;
    my ($rw, $zeile, $i, @rawdata);
    # Lese Datei
    $rw = open(FILE,$filename);
    if(not defined($rw)) {
        die "Fehler beim ffnen der Datei: $!\n";
    }
    # Array befllen
    while ($zeile = (<FILE>)) {
        $rawdata[$i++] = $zeile;
    }
    close(FILE);
    return @rawdata;
}

# Datei schreiben
sub writefile {
    my $filename = shift;
    my $ary_ref = shift;
    my $rw;
    
    $rw = open(FILE,">$filename");
    if(not defined($rw)) {
        die "Fehler beim ffnen der Datei: $!\n";
    }
    print FILE @$ary_ref;
    close(FILE);
}


##################################### osdserver #######################################

# Some generic stuff for handling a connection

sub NetError(*) {
    # Network error
    my ($msg)=@_;
    print STDERR "$msg\n";
    exit 1;
}

sub error() {
    # Fatal error. Send quit command, close socket and terminate.
    SendCmd("Quit");

	close SOCK;

    exit 1;
}

sub ConnectServer(**) {
    # Connect to the OSDServer
    my ($host,$port)=@_;    
    
    my $iaddr = inet_aton($host)                || NetError("no host: $host");
    my $paddr = sockaddr_in($port, $iaddr);
    
    my $proto = getprotobyname('tcp');
    socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || NetError("socket: $!");
    connect(SOCK, $paddr)                       || NetError("connect: $!");
    select(SOCK); $| = 1; select(STDOUT);
}

my @reply2xx;
my @reply3xx;
my @reply4xx;
my @reply5xx;
my @reply6xx;

sub ReadReply() {
    # Read a complete server reply until 2xx return code,
    # and store replies in each category by number
	@reply2xx=undef;
	@reply3xx=undef;
	@reply4xx=undef;
	@reply5xx=undef;
	@reply6xx=undef;
	
	while (<SOCK>) {
	    chomp;
	    $_ =~ s/\r$//;
	    
		print "< $_\n";
		# screen echo
		
		if ($_ =~ /^2/) { @reply2xx=split(/\s+/,$_,2); last; }
		if ($_ =~ /^3/) { @reply3xx=split(/\s+/,$_); }
		if ($_ =~ /^4/) { @reply4xx=split(/\s+/,$_,2); }
		if ($_ =~ /^5/) { @reply5xx=split(/\s+/,$_,2); }
		if ($_ =~ /^6/) { 
		    my @tmpreply6xx=split(/\s+/,$_,2); 
		    if (defined $reply6xx[0] && $reply6xx[0] == $tmpreply6xx[0]) {
		        $tmpreply6xx[1] = "$tmpreply6xx[1]\n$reply6xx[1]";
		    }
		    @reply6xx = @tmpreply6xx;
		}
	}
	return $false if defined $reply4xx[0];
	return $true;
}

sub SendCmd(*) {
    # Send a command and read the reply

	my ($cmd)=@_;
	
	print "> $cmd\n";
	# screen echo
	
	print SOCK "$cmd\n";
	# network send
	
	return ReadReply;
}

sub IsEvent(**) {
    # Helper to check reply for a certain event

    my ($obj,$ev) = @_;
    return $false if !defined $reply3xx[0];
    return $false if $reply3xx[0] != 300;
    return $false if $reply3xx[1] ne $obj;
    return $false if $reply3xx[2] ne $ev;

    return $true;
}


sub QuoteString(*) {
    # Quote arbitrary string for use in '' and ""
    my ($str)=@_;
    
    $str =~ s/\\/\\\\/g;
    $str =~ s/'/\\'/g;
    $str =~ s/"/\\"/g;
    $str =~ s/\r/\\r/g;
    $str =~ s/\n/\\n/g;
    $str =~ s/\t/\\t/g;
       
    return $str;   
}

sub UnquoteString(*) {
    # Unquote string
    my ($str)=@_;
    
    $str =~ s/\\'/'/g;
    $str =~ s/\\"/"/g;
    $str =~ s/\\r/\r/g;
    $str =~ s/\\n/\n/g;
    $str =~ s/\\t/\t/g;
    $str =~ s/\\\\/\\/g;
       
    return $str;   
}

# Enough generic stuff, now for some hello world


sub explode($$;$)
{
 my ($separator,$string,$limit) = @_;
 my @splitted;
 my $x       = 1;
 my $offset  = 0;
 my $sep_len = length($separator);

 while((my $pos = index($string,$separator,$offset)) >= 0 && (!$limit || $x < $limit))
 {
  my $part = substr($string,$offset,$pos-$offset);
  push(@splitted,$part);
  $offset = $pos+$sep_len;
  $x++;
 }
 push(@splitted,substr($string,$offset,length($string)-$offset));
 return @splitted;
}

sub GetUrl(*) {
    my $p = shift;
    my @UrlList;
    @UrlList = readfile("$tempdir/surfer.tmp.lnk");
    return ($UrlList[$p],$#UrlList) ;
}

sub ReadSettings()
{
    my @confitem;
    @confitem = readfile("$conffile");
    if (!defined $confitem[0]) { $width = 80; } else { $width = $confitem[0]; chomp($width);}
    if (!defined $confitem[1]) { $recursiv = 1; } else { $recursiv = $confitem[1]; chomp($recursiv);}    
}

sub WriteSettings()
{
    open(my $writef,">","$conffile") or die "Unable to Write to File: $!";
    print $writef $width;
    print $writef "\n";	    
    print $writef $recursiv;
    print $writef "\n";	    
    close($writef);
}

sub Settings() {
    SendCmd "settings=New Menu 'Settings'" or return $false;
    SendCmd "settings.SetColumns 10" or return $false;
    SendCmd "settings.EnableEvent close keyRed keyBlue" or return $false;
    SendCmd "settings.SetColorKeyText -red 'Save'" or return $false;
    SendCmd "settings.SetColorKeyText -blue 'Exit'" or return $false;
    SendCmd "settings.AddNew OsdItem -unselectable '--- Lynx Breite ---'" or return $false;
    SendCmd "getlynx=settings.AddNew EditIntItem -min 50 -max 120 Breite $width" or return $false;
    SendCmd "settings.AddNew OsdItem -unselectable '--- Beitrge recursiv anzeigen ---'" or return $false;
    SendCmd "recursiv=settings.AddNew EditIntItem -min 0 -max 1 -minstring No -maxstring Yes Recursiv $recursiv" or return $false;
    SendCmd "menu.addsubmenu settings" or return $false;
    SendCmd "getlynx.setcurrent" or return $false;    
    SendCmd "settings.show" or return $false;

    while (1) {
        SendCmd "settings.SleepEvent" or return $false;

        if (IsEvent("settings","keyRed")) {
            SendCmd "getlynx.GetValue" or return $false;
            if (!defined $reply6xx[0] || $reply6xx[0] != 600) { return $false; }
            $width = $reply6xx[1];
            SendCmd "recursiv.GetValue" or return $false;
            if (!defined $reply6xx[0] || $reply6xx[0] != 600) { return $false; }
            $recursiv = $reply6xx[1];
            SendCmd "settings.SendState osBack" or return $false;
            SendCmd "delete settings" or return $false;
	    WriteSettings;
            return $true;
        }
        elsif (IsEvent("settings","close")) {
            SendCmd "delete settings" or return $false;
            return $true;
        }
        elsif (IsEvent("settings","keyBlue")) {
            SendCmd "delete settings" or return $false;
            return $true;
        }

    }
}


sub ReadThread(*) {
    $pointer = shift;
    my (@result,@Thread,$QThread,$i);
    @result = GetUrl($pointer);
    my $url = $result[0];
    my $totallink = $result[1];
    my $sp = $pointer + 1;
    my $tsp = $result[1] + 1; 
    $i = 0;

    SendCmd "submenu=New Menu 'Beitrag $sp / $tsp'" or return $false;
    SendCmd "smenu.addsubmenu submenu" or return $false;
    SendCmd "submenu.SetColorKeyText -red 'Zurck'" or return $false;
    SendCmd "submenu.SetColorKeyText -green 'Vorwrts'" or return $false;
    SendCmd "submenu.SetColorKeyText -blue 'Verlassen'" or return $false;
    SendCmd "submenu.EnableEvent keyRed keyGreen keyBlue keyOk close" or return $false;    

    SendCmd "Message -status 'Downloading Link $sp'" or return $false;    
    thread($url,0,$width);
    @Thread = readfile("$tempdir/surfer.tmp");
    SendCmd "Message -statusclear" or return $false;

    while ( $i < @Thread ) {
	$QThread = QuoteString($Thread[$i]);
        SendCmd "s1opt$i=submenu.AddNew OsdItem '$QThread'" or return $false;	
	$i++;
    }

    SendCmd "smenu.SETCURRENT $pointer" or return $false;	
    SendCmd "submenu.show" or return $false;    

    while (1) {
        SendCmd "submenu.SleepEvent" or return $false;
        
	if (IsEvent("submenu","close")) {
            SendCmd "submenu.SendState osBack" or return $false;
	    SendCmd "delete submenu" or return $false;
	    return 0;
	}
        elsif (IsEvent("submenu","keyRed")) {
	    if ($pointer > 0) {
                SendCmd "submenu.SendState osBack" or return $false;
	        SendCmd "delete submenu" or return $false;
		$pointer--;
		return 1;
	    } else {
		SendCmd "submenu.SendState osBack" or return $false;
		SendCmd "delete submenu" or return $false;
		return 0;
	    }
	}
        elsif (IsEvent("submenu","keyGreen")) {
	    if ($pointer < $totallink) {
                SendCmd "submenu.SendState osBack" or return $false;
	        SendCmd "delete submenu" or return $false;
		$pointer++;
		return 1;
	    } else {
		SendCmd "submenu.SendState osBack" or return $false;
		SendCmd "delete submenu" or return $false;
		return 0;
	    }
	}
        elsif (IsEvent("submenu","keyBlue")) {
            SendCmd "submenu.SendState osBack" or return $false;
            SendCmd "delete submenu" or return $false;
	    return 0;	    
	}
	elsif (IsEvent("submenu","keyOk")) {
	    SendCmd "submenu.SendState osBack" or return $false;
            SendCmd "delete submenu" or return $false;
	    return 0;
	}
    }
}


sub SubBoard(*;*;*) {
    my ($BoardName,$BoardUrl,$Links) = @_;
    my ($i,$y,@ThreadList,@UrlList,$Thread,$result);
    $y = 0; 
    $i = 0;

    SendCmd "smenu=New Menu '$BoardName'" or return $false;
    SendCmd "menu.addsubmenu smenu" or return $false;
    SendCmd "smenu.SetColorKeyText -red 'Main'" or return $false;
    SendCmd "smenu.EnableEvent keyOk close keyRed" or return $false;   

    SendCmd "Message -status 'Downloading....'" or return $false;
    board($BoardUrl,$Links);
    SendCmd "Message -statusclear" or return $false;

    @ThreadList = readfile("$tempdir/surfer.tmp");

    while ( $i < @ThreadList ) {
        $Thread = QuoteString($ThreadList[$i]);
	if ( substr($Thread,0,1) eq "[" ) { 
	    SendCmd "sopt$y=smenu.AddNew OsdItem '$Thread'" or return $false;
	    SendCmd "sopt$y.EnableEvent keyOk" or return $false;
	    $y++;
        } 
#
# 	(1) Wenn die else Bedingung auskommentiert wird funktioniert beim Blttern (Red, Green) der Rcksprung
#     	mit Back nicht mehr korrekt --> es wird dann nicht mehr auf den richtigen Beitrag gesprungen.
#
#	else {
#	    SendCmd "srem$i=smenu.AddNew OsdItem -unselectable '$Thread'" or return $false;
#	}	
	$i++;
    }
    SendCmd "smenu.show" or return $false;    

    while (1) {
        SendCmd "smenu.SleepEvent" or return $false;
        if (IsEvent("smenu","keyRed")) {
            SendCmd "smenu.SendState osBack" or return $false;
	    SendCmd "delete smenu" or return $false;
	    return;
	}
	elsif (IsEvent("smenu","close")) {
            SendCmd "smenu.SendState osBack" or return $false;
	    SendCmd "delete smenu" or return $false;
	    return;
    	}
	elsif (IsEvent("smenu","keyOk")) {
    	    SendCmd "smenu.GETCURRENT" or return $false;
	    if (!defined $reply3xx[0] || $reply3xx[0] != 302) { return $false; }
	    if ( substr($reply3xx[2],0,4) eq "sopt" ) {
		$result = substr($reply3xx[2],4,8);
		$pointer = $result;
		while (1) {
		    if ( !ReadThread($pointer) ) {last;}		    
		}
#
# 		(1) Funktioniert nicht richtig wenn ein Eintrag (-unselectable) ber mehrere Zeilen 
#		geht i.V. weiterblttern mit Green - Red -> Back		
#
		SendCmd "smenu.SETCURRENT $pointer" or return $false;	
    		SendCmd "smenu.show" or return $false;
	    }
	}
    }
}



sub ShowUrls() {
    my ($i,$y,@UrlEntry,$result);
    $y = 0;
    $i = 0;

    SendCmd "menu=New Menu 'VDR-Portal'" or return $false;
    SendCmd "menu.SetColorKeyText -blue 'Exit'" or return $false;
    SendCmd "menu.SetColorKeyText -yellow 'Settings'" or return $false;    
    SendCmd "menu.EnableEvent keyOk keyBlue keyYellow close" or return $false;

    while ( $i < @UrlList) {
	@UrlEntry = explode(";",$UrlList[$i++]);
	if ($UrlEntry[0] eq "REM") {
	    my $remark = QuoteString($UrlEntry[1]);
	    SendCmd "menu.AddNew OsdItem -unselectable '$remark'" or return $false;	
	} else {
	    SendCmd "opt$y=menu.AddNew OsdItem '$UrlEntry[0]'" or return $false;
    	    SendCmd "opt$y.EnableEvent keyOk" or return $false;
	    $y++;
	}
    }
    SendCmd "menu.Show" or return $false;

    while (1) {
        SendCmd "menu.SleepEvent" or return $false;	
	if (IsEvent("menu","keyBlue")) {
	    SendCmd "menu.SendState osEnd" or return $false;
            SendCmd "delete menu" or return $false;
	    return;
    	}
	if (IsEvent("menu","keyYellow")) {
	    Settings;
	    ReadSettings;
    	}
	elsif (IsEvent("menu","close")) {
            SendCmd "menu.SendState osEnd" or return $false;
	    SendCmd "delete menu" or return $false;
	    return;
    	}
    	elsif (IsEvent("menu","keyOk")) {
	    SendCmd "menu.GETCURRENT" or return $false;
	    if (!defined $reply3xx[0] || $reply3xx[0] != 302) { return $false; }
	    $result = $reply3xx[1];
	    if (substr($reply3xx[2],0,3) eq "opt") {
		@UrlEntry = explode(";",$UrlList[$result]);
    		SubBoard($UrlEntry[0],$UrlEntry[1],1);
	    }
	}
    }
}




###############
#  Main Code  #
###############

ConnectServer localhost,2010;
# Connect to the server process

ReadReply;
# Read server welcome

SendCmd "Version 0.1" or error;
# Identify to server with protocol version#

ReadSettings() or error;
ShowUrls() or error;

SendCmd "Quit";
# ... and good bye

close(SOCK);
# close socket
